## ros-melodic-boost-sml 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(boost_sml)

# C++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

# Warnings
add_definitions(-W -Wall -Wextra
  -Wwrite-strings -Wunreachable-code -Wpointer-arith
  -Winit-self -Wredundant-decls
  -Wno-unused-parameter -Wno-unused-function)

# Find catkin macros and libraries
find_package(catkin REQUIRED COMPONENTS
  roscpp
  roslint
)

# System dependencies are found with CMake's conventions
find_package(Boost REQUIRED)

###################################
## Catkin specific configuration ##
###################################
catkin_package(
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    roscpp
  INCLUDE_DIRS
    include
  DEPENDS
    Boost
)

###########
## Build ##
###########

# Specify additional locations of header files
# Your package locations should be listed before other locations
include_directories(
  SYSTEM
    ${Boost_INCLUDE_DIR}
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(
  ${PROJECT_NAME}
  src/example.cpp
)

target_link_libraries(
  ${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_executable(sml_graph_demo src/sml_graph_demo.cpp)

#############
## Install ##
#############

# Install library
install(
  TARGETS
    ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

# Mark cpp header files for installation
install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION
    ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
endif()

## Test for correct C++ source code
roslint_cpp()

=== debian/changelog ===
ros-melodic-boost-sml (0.1.0-3stretch) stretch; urgency=high

  * [feature] Generate SML diagrams using boost.Graph (#4 <https://github.com/PickNikRobotics/boost_sml/issues/4>)
  * [feature] example source to enable catkin to build package that can be depended on (#2 <https://github.com/PickNikRobotics/boost_sml/issues/2>)
  * [fix] undefined reference error (#6 <https://github.com/PickNikRobotics/boost_sml/issues/6>)
    * Change static constexpr into const to avoid compiler errors when building in debug mode doesn't inline variables.
  * [fix] compilation errors when setting overriding CMAKE_CXX_STANDARD in catkin config. (#5 <https://github.com/PickNikRobotics/boost_sml/issues/5>)
  * [maint] move all headers into one directory (#3 <https://github.com/PickNikRobotics/boost_sml/issues/3>)
  * Contributors: JafarAbdi, Jere Liukkonen, Mark Moll, Tyler Weaver, picknik-jliukkonen

 -- Tyler Weaver <tyler@picknik.ai>  Tue, 13 Oct 2020 06:00:00 -0000

=== debian/control ===
Source: ros-melodic-boost-sml
Section: misc
Priority: optional
Maintainer: Tyler Weaver <tyler@picknik.ai>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-rosunit
Homepage: https://boost-experimental.github.io/sml/
Standards-Version: 3.9.2

Package: ros-melodic-boost-sml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roscpp, ros-melodic-roslint
Description: State machine library with ros logging

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-boost-sml//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-boost-sml 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,12 +4,6 @@
 # C++14
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED YES)
-
-# Warnings
-add_definitions(-W -Wall -Wextra
-  -Wwrite-strings -Wunreachable-code -Wpointer-arith
-  -Winit-self -Wredundant-decls
-  -Wno-unused-parameter -Wno-unused-function)
 
 # Find catkin macros and libraries
 find_package(catkin REQUIRED COMPONENTS
@@ -18,14 +12,14 @@
 )
 
 # System dependencies are found with CMake's conventions
-find_package(Boost REQUIRED)
+find_package(Boost REQUIRED COMPONENTS system)
 
 ###################################
 ## Catkin specific configuration ##
 ###################################
 catkin_package(
   LIBRARIES
-    ${PROJECT_NAME}
+    ${PROJECT_NAME}_example
   CATKIN_DEPENDS
     roscpp
   INCLUDE_DIRS
@@ -50,18 +44,26 @@
   ${catkin_INCLUDE_DIRS}
 )
 
+# Example Library that uses boost_sml
 add_library(
-  ${PROJECT_NAME}
-  src/example.cpp
+  ${PROJECT_NAME}_example
+  src/example_library.cpp
 )
-
 target_link_libraries(
-  ${PROJECT_NAME}
+  ${PROJECT_NAME}_example
   ${catkin_LIBRARIES}
   ${Boost_LIBRARIES}
 )
 
-add_executable(sml_graph_demo src/sml_graph_demo.cpp)
+# Example graph executable
+add_executable(sml_graph_demo
+  src/sml_graph_demo.cpp
+)
+target_link_libraries(
+  sml_graph_demo
+  ${catkin_LIBRARIES}
+  ${Boost_LIBRARIES}
+)
 
 #############
 ## Install ##
@@ -70,7 +72,8 @@
 # Install library
 install(
   TARGETS
-    ${PROJECT_NAME}
+    ${PROJECT_NAME}_example
+    sml_graph_demo
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
   RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}

=== debian/changelog ===
ros-melodic-boost-sml (0.1.2-1bionic) bionic; urgency=high

  * Add GitHub actions (#7 <https://github.com/PickNikRobotics/boost_sml/issues/7>)
  * Fix Debian Buster build
  * Contributors: Tyler Weaver

 -- Tyler Weaver <tyler@picknik.ai>  Tue, 20 Apr 2021 06:00:00 -0000

ros-melodic-boost-sml (0.1.1-1bionic) bionic; urgency=high

  * Add system component to boost cmake include
  * Add boost as dependency in package.xml
  * Contributors: Tyler Weaver

 -- Tyler Weaver <tyler@picknik.ai>  Wed, 28 Oct 2020 06:00:00 -0000

ros-melodic-boost-sml (0.1.0-1bionic) bionic; urgency=high

  * [feature] Generate SML diagrams using boost.Graph (#4 <https://github.com/PickNikRobotics/boost_sml/issues/4>)
  * [feature] example source to enable catkin to build package that can be depended on (#2 <https://github.com/PickNikRobotics/boost_sml/issues/2>)
  * [fix] undefined reference error (#6 <https://github.com/PickNikRobotics/boost_sml/issues/6>)
    * Change static constexpr into const to avoid compiler errors when building in debug mode doesn't inline variables.
  * [fix] compilation errors when setting overriding CMAKE_CXX_STANDARD in catkin config. (#5 <https://github.com/PickNikRobotics/boost_sml/issues/5>)
  * [maint] move all headers into one directory (#3 <https://github.com/PickNikRobotics/boost_sml/issues/3>)
  * Contributors: JafarAbdi, Jere Liukkonen, Mark Moll, Tyler Weaver, picknik-jliukkonen

 -- Tyler Weaver <tyler@picknik.ai>  Tue, 13 Oct 2020 06:00:00 -0000

=== debian/control ===
Source: ros-melodic-boost-sml
Section: misc
Priority: optional
Maintainer: Tyler Weaver <tyler@picknik.ai>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-melodic-catkin, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-rosunit
Homepage: https://boost-experimental.github.io/sml/
Standards-Version: 3.9.2

Package: ros-melodic-boost-sml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-melodic-roscpp, ros-melodic-roslint
Description: State machine library with ros logging
